Code

events which have no local server implementation are forwarded to client if the clien...
[gosa.git] / gosa-core / dh-make-gosa
1 #!/bin/bash
3 usage() {
4   echo "Usage: ${0##*/} [--download] [-b|--branch branch] [-e|--email mail] [--depends] plugin-dir|plugin.tar.gz" >&2
5   exit 1
6 }
9 load_dsc() {
10   if [ -r "$1" ]; then
11     PL_NAME=$(sed -n 's/"//g;s/^name\s*=\s*\(.*\)$/\1/p' "$1")
12     PL_VERSION=$(sed -n 's/"//g;s/^version\s*=\s*\(.*\)$/\1/p' "$1")
13     TDEPENDS=$(sed -n 's/"//g;s/^depends\s*=\s*\(.*\)$/\1/p' "$1")
14     for dep in $TDEPENDS; do
15       PL_DEPENDS="gosa-plugin-$dep, $PL_DEPENDS"
16     done
17     PL_DESCRIPTION=$(sed -n 's/"//g;s/^description\s*=\s*\(.*\)$/\1/p' "$1")
18     PL_AUTHOR=$(sed -n 's/"//g;s/^author\s*=\s*\([^<]*\).*$/\1/p' "$1")
19     PL_MAIL=$(sed -n 's/"//g;s/^author\s*=[^<].*<\([^>]*\).*$/\1/p' "$1")
20   else
21     echo "Error: cannot find description file" >&2
22     exit 1
23   fi
24 }
27 TEMP=`getopt -o e:r: --long download,release:,email:,depends: -n 'dh-make-gosa' -- "$@"`
28 if [ $? != 0 ] ; then
29   echo "Error: cannot get command line information" >&2
30   exit 1
31 fi
33 eval set -- "$TEMP"
35 # Load command  line vars
36 RELEASE=trunk
37 DOWNLOAD=
38 DEPENDS=
39 DEST=
40 while true; do
41   case "$1" in
42     -e|--email) DEBMAIL=$2
43                 shift 2
44                 ;;
45     -r|--release)
46                 if [ "$2" != "trunk" ]; then
47                   RELEASE=tags/$2
48                 fi
49                 shift 2
50                 ;;
51     --depends)  DEPENDS="$2"
52                 shift 2
53                 ;;
54     --dest)     DEST=$2/
55                 shift 2
56                 ;;
57     --download) DOWNLOAD=yes
58                 shift 1
59                 ;;
60     --)         shift
61                 break
62                 ;;
63     *)          usage
64                 ;;
65   esac
66 done
68 [ $# -ne 1 ] && usage
69 file=$*
71 # Three possiblities
72 if [ -d "$file" ]; then
74   # It's a local directory
75   load_dsc $file/plugin.dsc
77   # Setup build environment
78   if [ "$OVERRIDE_VERSION" ]; then
79           BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${OVERRIDE_VERSION}
80   else
81           BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
82   fi
83   if [ -d "$BUILD_PATH" ]; then
84     echo "Error: build path $BUILD_PATH already exists" >&2
85     exit 2
86   fi
87   cp -a "$PL_NAME" "$BUILD_PATH"
89 elif [ -f "$file" ]; then
91   # It's a compressed user contributed file
92   TMPDIR="/tmp/dh-make-gosa-$PPID"
93   if [ -d "/tmp/dh-make-gosa-$PPID"  ]; then
94     echo "Error: directory $TMPDIR exists" >&2
95     exit 4
96   fi
98   # Untar
99   mkdir -p "$TMPDIR"
100   tar --extract --directory "$TMPDIR" -fz "$file" &> /dev/null
101   if [ $? -ne 0 ]; then
102     echo "Error: cannot extract plugin file - invalid file format" >&2
103     exit 5
104   fi
106   # It's a local directory
107   load_dsc TMPDIR/*/plugin.dsc
109   # Setup build environment
110   BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
111   mv "$TMPDIR/*" "$BUILD_PATH"
113 else
115   echo "Error: cannot find plugin $file" >&2
116   exit 5
118 fi
121 PL_DEPENDS=$(echo $PL_DEPENDS$DEPENDS | sed 's/,\s*$//')
122 echo "Debian package summary ========================================"
123 echo "Plugin:       $PL_NAME"
124 echo "Version:      $PL_VERSION"
125 echo "Description:  $PL_DESCRIPTION"
126 echo "Depends:      $PL_DEPENDS"
127 echo "Author name:  $PL_AUTHOR"
128 echo "Author email: $PL_MAIL"
129 echo
130 read -s -n 1 -p "Do you want to continue? (y/n)" ans; echo
131 [ "$ans" != "y" ] && exit 0
133 pushd . &> /dev/null
135 cd "$BUILD_PATH"
137 # Use gosa-plugin skelleton
138 echo "Calling dh_make..."
139 echo | dh_make -e "$PL_MAIL" -c gpl -s -n -f gosa-plugin-${PL_NAME}-${PL_VERSION}.tar.gz &> /dev/null
140 if [ $? -ne 0 ]; then
141         echo "Failed to call dh_make - aborting!"
142         exit 1
143 fi
145 echo "Apdapting debian descriptive files..."
147 # Generate install file
148 for dir in admin personal addons; do
149         [ -d $dir ] && echo -e "$dir\t\t\t/usr/share/gosa/plugins" >> debian/install
150 done
151 for dir in help/*; do
152         echo -e "$dir\t\t\t/usr/share/gosa/doc/plugins/$PL_NAME" >> debian/install
153 done
154 for dir in $(ls -1 locale | grep -v "^en$" | grep -v "^messages.po$"); do
155         echo -e "locale/$dir\t\t\t/usr/share/gosa/locale/plugins/$PL_NAME" >> debian/install
156 done
158 # Generate dirs
159 echo "usr/share/gosa" > debian/dirs
161 # If we've a contrib directory include it to the docs
162 if [ -d contrib ]; then
163         echo "contrib /usr/share/doc/gosa-plugin-$PL_NAME" >> debian/install
164 fi
165 if [ -d html ]; then
166         for i in html/*; do
167                 echo "$i /usr/share/gosa/html/plugins/$PL_NAME" >> debian/install
168         done
169 fi
171 # Fix copyright
172 sed -i '/^#/d;/^.*likewise for another author.*$/d' debian/copyright
173 year=$(date +%Y)
174 sed -i "s/.Copyright (C) YYYY Name OfAuthor./Copyright (C) $year $PL_AUTHOR/g" debian/copyright
175 sed -i "s/.url:\/\/example.com./http:\/\/www.gosa-project.org/g" debian/copyright
176 sed -i "/.put author's name and email here.\
177 /d" debian/copyright
178 sed -i '/^Upstream/,/^$/d' debian/copyright
180 # Adapt control
181 sed -i 's/^Section: unknown/Section: web/g' debian/control
182 sed -i 's/^Architecture: any/Architecture: all/g' debian/control
183 sed -i 's/^Depends: .*$/Depends: gosa/g' debian/control
184 sed -i "s/^Description: .*$/Description: $PL_NAME plugin for GOsa/g" debian/control
185 sed -i "s/^ <.*$/ %DESCRIPTION%/g" debian/control
186 dsc=$(tempfile)
188 echo $PL_DESCRIPTION 
189 cat <<EOF
191 GOsa is a combination of system-administrator and end-user web
192 interface, designed to handle LDAP based setups.
193 EOF
194 }| fmt -suw79 | sed 's/^/ /g' > $dsc
195 sed -i "/%DESCRIPTION%/r $dsc" debian/control
196 sed -i "/%DESCRIPTION%/d" debian/control
197 rm $dsc
199 # Adapt README.debian
200 cat <<EOF > debian/README.Debian
201 README.Debian for GOsa $PL_NAME plugin $PL_VERSION
202 -------------------------------------------
204 Please read the main GOsa README.Debian file for more information.
206 ----
207 $PL_AUTHOR <$PL_MAIL>  Fri 02 Jun 2006 16:23:50 +0200
208 EOF
210 # Fix README
211 sed -i "s/Comments regarding the Package/After installing this plugin you may need to reload apache../g" debian/README
213 # Fix rules
214 cat <<EOF > debian/rules
215 #!/usr/bin/make -f
216 # -*- makefile -*-
217 # GOsa default plugin debhelper file.
218 # This file was originally written by Joey Hess and Craig Small.
219 # As a special exception, when this file is copied by dh-make into a
220 # dh-make output file, you may use that output file without restriction.
221 # This special exception was added by Craig Small in version 0.37 of dh-make.
223 # Uncomment this to turn on verbose mode.
224 #export DH_VERBOSE=1
226 configure: configure-stamp
227 configure-stamp:
228         dh_testdir
229         touch configure-stamp
232 build: build-stamp
234 build-stamp: configure-stamp 
235         dh_testdir
237         touch $@
239 clean:
240         dh_testdir
241         dh_testroot
242         rm -f build-stamp configure-stamp
243         dh_clean 
245 install: build
246         dh_testdir
247         dh_testroot
248         dh_clean -k 
249         dh_installdirs
251 # Build architecture-independent files here.
252 binary-indep: build install
253         dh_testdir
254         dh_testroot
255         dh_installchangelogs 
256         dh_installdocs
257         dh_installexamples
258         dh_install
259         dh_installman
260         dh_strip
261         dh_compress
262         dh_fixperms
263         dh_installdeb
264         dh_gencontrol
265         dh_md5sums
266         dh_builddeb
268 binary: binary-indep
269 .PHONY: build clean binary-indep binary install configure
270 EOF
272 # Adapt postinst/postrm
273 for file in postinst postrm; do
274 sed 's!#DEBHELPER#!#DEBHELPER#\
276 # Get apache versions running\
277 servers=""\
278 for srv in apache apache-ssl apache2; do\
279         if [ -x /usr/sbin/$srv ]; then\
280                 servers="$srv $servers"\
281         fi\
282 done\
284 # Update gosa\
285 /usr/sbin/update-gosa\
287 # Finally restart servers\
288 for server in $servers; do\
289         if [ -x /usr/sbin/invoke-rc.d ]; then\
290                 invoke-rc.d $server restart\
291         else\
292                 /etc/init.d/$server restart\
293         fi\
294 done\
296 !' debian/$file.ex > debian/$file
297 done
299 # Remove examples
300 rm debian/*ex debian/*EX &> /dev/null
302 popd &> /dev/null
304 echo "Done."